/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the MicrosoftAdsStaticUserAuthAllOf type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &MicrosoftAdsStaticUserAuthAllOf{}

// MicrosoftAdsStaticUserAuthAllOf struct for MicrosoftAdsStaticUserAuthAllOf
type MicrosoftAdsStaticUserAuthAllOf struct {
	DeveloperToken *string `json:"developerToken,omitempty"`
	ClientId       *string `json:"clientId,omitempty"`
	ClientSecret   *string `json:"clientSecret,omitempty"`
	RedirectUri    *string `json:"redirectUri,omitempty"`
	Tenant         *string `json:"tenant,omitempty"`
}

// NewMicrosoftAdsStaticUserAuthAllOf instantiates a new MicrosoftAdsStaticUserAuthAllOf object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMicrosoftAdsStaticUserAuthAllOf() *MicrosoftAdsStaticUserAuthAllOf {
	this := MicrosoftAdsStaticUserAuthAllOf{}
	return &this
}

// NewMicrosoftAdsStaticUserAuthAllOfWithDefaults instantiates a new MicrosoftAdsStaticUserAuthAllOf object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMicrosoftAdsStaticUserAuthAllOfWithDefaults() *MicrosoftAdsStaticUserAuthAllOf {
	this := MicrosoftAdsStaticUserAuthAllOf{}
	return &this
}

// GetDeveloperToken returns the DeveloperToken field value if set, zero value otherwise.
func (o *MicrosoftAdsStaticUserAuthAllOf) GetDeveloperToken() string {
	if o == nil || IsNil(o.DeveloperToken) {
		var ret string
		return ret
	}
	return *o.DeveloperToken
}

// GetDeveloperTokenOk returns a tuple with the DeveloperToken field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MicrosoftAdsStaticUserAuthAllOf) GetDeveloperTokenOk() (*string, bool) {
	if o == nil || IsNil(o.DeveloperToken) {
		return nil, false
	}
	return o.DeveloperToken, true
}

// HasDeveloperToken returns a boolean if a field has been set.
func (o *MicrosoftAdsStaticUserAuthAllOf) HasDeveloperToken() bool {
	if o != nil && !IsNil(o.DeveloperToken) {
		return true
	}

	return false
}

// SetDeveloperToken gets a reference to the given string and assigns it to the DeveloperToken field.
func (o *MicrosoftAdsStaticUserAuthAllOf) SetDeveloperToken(v string) {
	o.DeveloperToken = &v
}

// GetClientId returns the ClientId field value if set, zero value otherwise.
func (o *MicrosoftAdsStaticUserAuthAllOf) GetClientId() string {
	if o == nil || IsNil(o.ClientId) {
		var ret string
		return ret
	}
	return *o.ClientId
}

// GetClientIdOk returns a tuple with the ClientId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MicrosoftAdsStaticUserAuthAllOf) GetClientIdOk() (*string, bool) {
	if o == nil || IsNil(o.ClientId) {
		return nil, false
	}
	return o.ClientId, true
}

// HasClientId returns a boolean if a field has been set.
func (o *MicrosoftAdsStaticUserAuthAllOf) HasClientId() bool {
	if o != nil && !IsNil(o.ClientId) {
		return true
	}

	return false
}

// SetClientId gets a reference to the given string and assigns it to the ClientId field.
func (o *MicrosoftAdsStaticUserAuthAllOf) SetClientId(v string) {
	o.ClientId = &v
}

// GetClientSecret returns the ClientSecret field value if set, zero value otherwise.
func (o *MicrosoftAdsStaticUserAuthAllOf) GetClientSecret() string {
	if o == nil || IsNil(o.ClientSecret) {
		var ret string
		return ret
	}
	return *o.ClientSecret
}

// GetClientSecretOk returns a tuple with the ClientSecret field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MicrosoftAdsStaticUserAuthAllOf) GetClientSecretOk() (*string, bool) {
	if o == nil || IsNil(o.ClientSecret) {
		return nil, false
	}
	return o.ClientSecret, true
}

// HasClientSecret returns a boolean if a field has been set.
func (o *MicrosoftAdsStaticUserAuthAllOf) HasClientSecret() bool {
	if o != nil && !IsNil(o.ClientSecret) {
		return true
	}

	return false
}

// SetClientSecret gets a reference to the given string and assigns it to the ClientSecret field.
func (o *MicrosoftAdsStaticUserAuthAllOf) SetClientSecret(v string) {
	o.ClientSecret = &v
}

// GetRedirectUri returns the RedirectUri field value if set, zero value otherwise.
func (o *MicrosoftAdsStaticUserAuthAllOf) GetRedirectUri() string {
	if o == nil || IsNil(o.RedirectUri) {
		var ret string
		return ret
	}
	return *o.RedirectUri
}

// GetRedirectUriOk returns a tuple with the RedirectUri field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MicrosoftAdsStaticUserAuthAllOf) GetRedirectUriOk() (*string, bool) {
	if o == nil || IsNil(o.RedirectUri) {
		return nil, false
	}
	return o.RedirectUri, true
}

// HasRedirectUri returns a boolean if a field has been set.
func (o *MicrosoftAdsStaticUserAuthAllOf) HasRedirectUri() bool {
	if o != nil && !IsNil(o.RedirectUri) {
		return true
	}

	return false
}

// SetRedirectUri gets a reference to the given string and assigns it to the RedirectUri field.
func (o *MicrosoftAdsStaticUserAuthAllOf) SetRedirectUri(v string) {
	o.RedirectUri = &v
}

// GetTenant returns the Tenant field value if set, zero value otherwise.
func (o *MicrosoftAdsStaticUserAuthAllOf) GetTenant() string {
	if o == nil || IsNil(o.Tenant) {
		var ret string
		return ret
	}
	return *o.Tenant
}

// GetTenantOk returns a tuple with the Tenant field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MicrosoftAdsStaticUserAuthAllOf) GetTenantOk() (*string, bool) {
	if o == nil || IsNil(o.Tenant) {
		return nil, false
	}
	return o.Tenant, true
}

// HasTenant returns a boolean if a field has been set.
func (o *MicrosoftAdsStaticUserAuthAllOf) HasTenant() bool {
	if o != nil && !IsNil(o.Tenant) {
		return true
	}

	return false
}

// SetTenant gets a reference to the given string and assigns it to the Tenant field.
func (o *MicrosoftAdsStaticUserAuthAllOf) SetTenant(v string) {
	o.Tenant = &v
}

func (o MicrosoftAdsStaticUserAuthAllOf) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o MicrosoftAdsStaticUserAuthAllOf) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.DeveloperToken) {
		toSerialize["developerToken"] = o.DeveloperToken
	}
	if !IsNil(o.ClientId) {
		toSerialize["clientId"] = o.ClientId
	}
	if !IsNil(o.ClientSecret) {
		toSerialize["clientSecret"] = o.ClientSecret
	}
	if !IsNil(o.RedirectUri) {
		toSerialize["redirectUri"] = o.RedirectUri
	}
	if !IsNil(o.Tenant) {
		toSerialize["tenant"] = o.Tenant
	}
	return toSerialize, nil
}

type NullableMicrosoftAdsStaticUserAuthAllOf struct {
	value *MicrosoftAdsStaticUserAuthAllOf
	isSet bool
}

func (v NullableMicrosoftAdsStaticUserAuthAllOf) Get() *MicrosoftAdsStaticUserAuthAllOf {
	return v.value
}

func (v *NullableMicrosoftAdsStaticUserAuthAllOf) Set(val *MicrosoftAdsStaticUserAuthAllOf) {
	v.value = val
	v.isSet = true
}

func (v NullableMicrosoftAdsStaticUserAuthAllOf) IsSet() bool {
	return v.isSet
}

func (v *NullableMicrosoftAdsStaticUserAuthAllOf) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMicrosoftAdsStaticUserAuthAllOf(val *MicrosoftAdsStaticUserAuthAllOf) *NullableMicrosoftAdsStaticUserAuthAllOf {
	return &NullableMicrosoftAdsStaticUserAuthAllOf{value: val, isSet: true}
}

func (v NullableMicrosoftAdsStaticUserAuthAllOf) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMicrosoftAdsStaticUserAuthAllOf) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
